


Enumeration 200
  #Wnd_Main
  #Wnd_List
  #Wnd_Options
  #Wnd_Process
EndEnumeration

Enumeration 2000
  #Frame_Path
  #Str_Folder
  #Btn_Browse
  #Btn_Paste
  #Frame_Quality
  #Text_Format
  #Text_2
  #Combo_Format
  #Text_3
  #Combo_Compression
  #Frame_Size
  #Combo_Size
  #Str_Size
  #Text_Size1
  #Text_Size2
  #Btn_Quit
  #Btn_List
  #Text_Version
  
  #Btn_Toggle_After
  #Btn_Toggle_Before
  
  #Lst_Images
  #Text_WarningVideos
  #Btn_ReglerLesOptions
  
  #Text_Nb_Images
  #Chk_Rename
  #Str_Name
  #Text_StartAt
  #Str_StartAt
  #Chk_ChangeFolder
  #Str_Folder2
  #Btn_Browse2
  #Chk_RemoveOldImg
  #Chk_LcaseExt
  #Btn_StartProcess
  
  #Frame3D
  #ProgressBar
  #Chk_OpenFolder
  #Btn_CancelProcess
  #Text_4
  #Text_5
EndEnumeration





Procedure SetToogleButtonsState(state.b)
  DisableGadget(#Btn_Toggle_After,  state)
  DisableGadget(#Btn_Toggle_Before, state)
EndProcedure

Procedure ReadyForEncoding()
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    Separator.s = "\"
  CompilerElse
    Separator.s = "/"
  CompilerEndIf

  If GetGadgetState(#Chk_Rename) And CountString(GetGadgetText(#Str_Name), "#") <> 1
    Alert(Translate("Info.AlertFile.Diese"))
    ProcedureReturn #False
  EndIf
  If GetGadgetState(#Chk_Rename) And CountString(GetGadgetText(#Str_Name), Separator) > 0
    Alert(ReplaceString(Translate("Info.AlertFile.InvalidName"), "%", Separator))
    ProcedureReturn #False
  EndIf
  If GetGadgetState(#Chk_ChangeFolder) And FileSize(GetGadgetText(#Str_Folder2)) <> -2
    Alert(Translate("Info.AlertFile.NonExistingPath"))
    ProcedureReturn #False
  EndIf
  ProcedureReturn #True
EndProcedure


Procedure CreateWindows(*Options.Options)
  Protected WndOpt.l = #PB_Window_MinimizeGadget |#PB_Window_SystemMenu | #PB_Window_ScreenCentered
  
  ;{- Fentre principale
  If OpenWindow(#Wnd_Main, 0, 0, 340, 200, #PROJECT_NAME$ + " - "+Translate("Wnd.Title.Main"), WndOpt)
  ; creation de la liste d'objets
    Frame3DGadget (#Frame_Path,  5, 5, 330, 50, Translate("Frame.Path"))
    StringGadget  (#Str_Folder,  10, 25, 230, 22, GetKeyValue(#HKEY_CURRENT_USER, "Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders\", "My Pictures"))
    ButtonGadget  (#Btn_Browse, 245, 25, 40, 22, "...")
    ButtonGadget  (#Btn_Paste, 290, 25, 40, 22, "Ctrl+V")
    
    Frame3DGadget(#Frame_Quality, 5, 60, 330, 50, Translate("Frame.Quality"))
    TextGadget(#Text_Format, 15, 85, 100, 15, Translate("Text.Format")+" :")
    ComboBoxGadget(#Combo_Format, 75, 82, 60, 20) 
    AddGadgetItem(#Combo_Format, -1, "JPG")
    AddGadgetItem(#Combo_Format, -1, "PNG")
    AddGadgetItem(#Combo_Format, -1, "BMP")
    TextGadget(#Text_2, 190, 85, 130, 15, Translate("Text.Compression")+" :")  
    ComboBoxGadget(#Combo_Compression, 260, 82, 60, 20)
    For i.l = 0 To 10
      AddGadgetItem(#Combo_Compression, -1, Str(i))
    Next i
    SetGadgetState(#Combo_Format, 0) ; on slectionne par dfaut JPEG
    SetGadgetState(#Combo_Compression, *Options\CompressionLevel)
    
    Frame3DGadget(#Frame_Size, 5, 115, 330, 50, Translate("Frame.Size"))
    TextGadget(#Text_Size1, 15, 140, 90, 15, Translate("Text.Size"))
    ComboBoxGadget(#Combo_Size, 110, 137, 55, 20)
      AddGadgetItem(#Combo_Size, -1, Translate("Combo.Size.Other"))
      AddGadgetItem(#Combo_Size, -1, " 20%: 1/5")
      AddGadgetItem(#Combo_Size, -1, " 25%: 1/4")
      AddGadgetItem(#Combo_Size, -1, " 33%: 1/3")
      AddGadgetItem(#Combo_Size, -1, " 50%: 1/2")
      AddGadgetItem(#Combo_Size, -1, " 66%: 2/3")
      AddGadgetItem(#Combo_Size, -1, "100%: 1/1") ; index: 6
      AddGadgetItem(#Combo_Size, -1, "150%: 3/2")
      AddGadgetItem(#Combo_Size, -1, "200%: 2/1")
      AddGadgetItem(#Combo_Size, -1, "300%: 3/1")
      AddGadgetItem(#Combo_Size, -1, "400%: 4/1")
    TextGadget(#Text_Size2, 195, 140, 40, 15, Translate("Text.Ratio")+":")
    StringGadget(#Str_Size, 235, 137, 60, 20, "100%")
    HideGadget(#Text_Size2, #True): HideGadget(#Str_Size, #True)
    SetGadgetState(#Combo_Size, 6) ; on slectionne par dfaut 100%
    GadgetToolTip(#Str_Size, Translate("ToolTip.Ratio"))
    
    ButtonGadget(#Btn_List,  10, 170, 240 , 24, Translate("Button.List"))
    TextGadget(#Text_Version, 255, 180, 77, 20, ReplaceString(Translate("Text.Version"), "#", #VERSION_NUMBER), #PB_Text_Right)
    If LoadFont(0, "Palatino Linotype", 11, #PB_Font_Bold)
      SetGadgetFont(#Btn_List, FontID(0))   ; Set the loaded Arial 16 font as new standard
    EndIf

    ;ButtonGadget(#Btn_Quit, 170, 170, 70 , 24, "Quitter")
  EndIf
  ;}
  
  ;{- Fentre de choix des images
  If OpenWindow(#Wnd_List, 0, 0, 460, 340, #PROJECT_NAME$ + " - "+Translate("Wnd.Title.List"), #PB_Window_Invisible | WndOpt)
    ;If CreateGadgetList(WindowID(#Wnd_List))
      ListIconGadget(#Lst_Images, 10, 10, 440, 270, Translate("ListIcon.ImgList.File"), 355, #PB_ListIcon_CheckBoxes | #PB_ListIcon_GridLines)
      AddGadgetColumn(#Lst_Images, 1, Translate("ListIcon.ImgList.Size"), 80)
      TextGadget(#Text_WarningVideos, 80, 285, 300, 14, Translate("Info.ContainsVideo"), #PB_Text_Center)
      HideGadget(#Text_WarningVideos, #True)
      SetGadgetColor(#Text_WarningVideos, #PB_Gadget_FrontColor, $FF)
      SetGadgetColor(#Text_WarningVideos, #PB_Gadget_BackColor, $FFFF)
      
      ButtonGadget(#Btn_Toggle_Before, 10, 310, 100, 24, Translate("Button.ChangeBefore"))
      ButtonGadget(#Btn_Toggle_After, 120, 310, 100, 24, Translate("Button.ChangeAfter"))
      ButtonGadget(#Btn_ReglerLesOptions, 380, 310, 70, 24, Translate("Button.Next"))
      SetToogleButtonsState(#True)
      GadgetToolTip(#Btn_Toggle_Before, Translate("ToolTip.ChangeBefore"))
      GadgetToolTip(#Btn_Toggle_After , Translate("ToolTip.ChangeAfter"))
    ;EndIf
  EndIf
  ;}
  
  ;{- Fentre des options
  If OpenWindow(#Wnd_Options, 0, 0, 280, 220, #PROJECT_NAME$ + " - " + Translate("Wnd.Title.Compress"), #PB_Window_Invisible | WndOpt)
    ;If CreateGadgetList(WindowID(#Wnd_Options))
      TextGadget(#Text_Nb_Images, 10, 5, 260, 20, "")
      CheckBoxGadget(#Chk_Rename, 10, 30, 130, 20, Translate("Checkbox.RenameImage"))
      StringGadget(#Str_Name, 20, 50, 250, 20, #DEFAULT_FILENAME)
      TextGadget(#Text_StartAt, 20, 80, 150, 20, Translate("Text.Count")+":")
      SpinGadget(#Str_StartAt, 180, 77, 90, 20, 1, 30000, #PB_Spin_Numeric)
      CheckBoxGadget(#Chk_ChangeFolder, 10, 100, 155, 20, Translate("Checkbox.OtherFolder"))
      StringGadget(#Str_Folder2, 20, 120, 210, 20, GetDefaultDirectory())
      ButtonGadget(#Btn_Browse2, 240, 120, 30, 20, "...")
      CheckBoxGadget(#Chk_RemoveOldImg, 10, 140, 155, 20, Translate("Checkbox.DeleteImage"))
      CheckBoxGadget(#Chk_LcaseExt, 10, 160, 145, 20, Translate("Checkbox.ExtensionCase"))
      ButtonGadget(#Btn_StartProcess, 70, 190, 140, 24, Translate("Button.LaunchCompression"))
      
      SetGadgetState(#Chk_Rename,      *Options\RenameFiles)
        DisableGadget(#Str_Name, False(*Options\RenameFiles))
        DisableGadget(#Str_StartAt, False(*Options\RenameFiles))
      SetGadgetState(#Chk_ChangeFolder, *Options\MoveFolder)
        DisableGadget(#Str_Folder2, False(*Options\MoveFolder))
        DisableGadget(#Btn_Browse2, False(*Options\MoveFolder))
      SetGadgetState(#Chk_RemoveOldImg, *Options\DeleteOldImg)
      SetGadgetState(#Chk_LcaseExt,     *Options\ExtInLcase)
      SetGadgetState(#Str_StartAt, 1)
    ;EndIf
  EndIf
  ;}
  
  ;{- Fentre de progression
  If OpenWindow(#Wnd_Process, 0, 0, 319, 129, #PROJECT_NAME$, #PB_Window_Invisible | WndOpt)
    ;If CreateGadgetList(WindowID(#Wnd_Process))
      Frame3DGadget(#Frame3D, 10, 10, 300, 110, "")
      ProgressBarGadget(#ProgressBar, 20, 40, 270, 20, 0, 100)
      TextGadget(#Text_4, 20, 20, 120, 20, Translate("Text.Progression")+" :")
      TextGadget(#Text_5, 200, 20, 90, 20, "", #PB_Text_Right)
      CheckBoxGadget(#Chk_OpenFolder, 20, 65, 280, 20, Translate("Checkbox.OpenFolder"))
      ButtonGadget(#Btn_CancelProcess, 120, 90, 70, 20, Translate("Button.StopCompression"))
    ;EndIf
  EndIf
  ;}
EndProcedure



; IDE Options = PureBasic 4.50 (Windows - x86)
; CursorPosition = 135
; FirstLine = 114
; Folding = +-
; UseMainFile = ImagesCompressor.pb